# Noexception

## Installation

Add this line to your application's Gemfile:

```ruby
gem 'tmtms-noexception'
```

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install noexception

## Usage

```ruby
require 'noexception'

class Foo
  def abc
    raise 'abc error'
  end

  def xyz
    raise 'xyz error'
  end

  def bar
    123
  end
end

Foo.include NoException::No

foo = Foo.new
p foo.abc   #=> nil
p $error    #=> #<RuntimeError: abc error>
p foo.xyz   #=> nil
p $error    #=> #<RuntimeError: xyz error>
p foo.bar   #=> 123
```

```ruby
Foo.include NoException::No(:abc)

foo = Foo.new
p foo.abc   #=> nil
p $error    #=> #<RuntimeError: abc error>
p foo.xyz   #=> raise 'xyz error'
```

```ruby
Foo.include NoException::Go

foo = Foo.new
p foo.abc   #=> [nil, #<RuntimeError: abc error>]
p foo.bar   #=> [123, nil]
```

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/tmtm/noexception.
